package algorithmrepository.contouring;

/** Interface for providing callback function to Contouring */
public interface ContourCallback {
	
	/** Called for each point (x,y) on a contour. Return false to abort the contour */
	public boolean contourPoint(double contourValue, double x, double y);
	
	/** Called on completion of a single contour.  Return false to stop contouring 
	 * @param contourValue The value of f at which the contour is. 
	 * @param terminationReason The reason the contour ended, one of the Contouring.RETURN_ values.
	 * */
	public boolean contourEnd(double contourValue, int terminationReason);	

}
